import { toolAdd, toolUpdate } from "@/api/bussiness";
// 提交表单的 hooks
const useSubmitForm = (getList) => {
  const { proxy } = getCurrentInstance();
  // 弹窗是否打开
  const open = ref(false);
  // 弹窗的标题
  const title = ref("");
  // 表单的 loading 状态
  const formLoading = ref(false);
  // 提交表单loading
  const submitLoading = ref(false);
  const data = reactive({
    // 表单数据
    form: {
      toolName: undefined,
    },
    // 表单规则
    rules: {
      toolName: [
        { required: true, message: "工具名称不能为空", trigger: "blur" },
      ],
    },
  });

  const { form, rules } = toRefs(data);

  // 表单重置
  const reset = () => {
    form.value = {
      toolName: undefined,
    };
    proxy.resetForm("toolTypesRef");
  };

  // 更新工具
  const updateToolType = () => {
    const baseParams = {
      ...form.value,
    };
    toolUpdate(baseParams)
      .then((res) => {
        proxy.$modal.msgSuccess("修改成功");
        open.value = false;
        getList();
      })
      .finally(() => {
        submitLoading.value = false;
      });
  };

  // 添加工具
  const addToolType = () => {
    const params = {
      ...form.value,
    };
    toolAdd(params)
      .then((res) => {
        proxy.$modal.msgSuccess("新增成功");
        submitLoading.value = false;
        open.value = false;
        getList();
      })
      .finally(() => {
        submitLoading.value = false;
      });
  };

  // 提交按钮
  const submitForm = () => {
    proxy.$refs["toolTypesRef"].validate((valid) => {
      if (valid) {
        submitLoading.value = true;
        if (form.value.id != undefined) {
          updateToolType();
        } else {
          addToolType();
        }
      }
    });
  };
  // 取消按钮
  const cancel = () => {
    open.value = false;
    reset();
  };
  return {
    title,
    open,
    form,
    rules,
    formLoading,
    submitLoading,
    reset,
    submitForm,
    cancel,
  };
};

export default useSubmitForm;
