import { getToolDetailById, toolDelete } from "@/api/bussiness";

// 数据表格的 hooks
const useTable = (getList, reset, open, title, form, formLoading) => {
  const { proxy } = getCurrentInstance();
  // 表格数据列表
  const toolList = ref([]);
  // 表格loading状态
  const loading = ref(true);
  // 表格勾选框选中的 id 列表
  const ids = ref([]);
  // 多个勾选时为 true 其他为 false
  const single = ref(true);
  // 只要有勾选项就为 true
  const multiple = ref(true);

  // 多选框选中数据
  const handleSelectionChange = (selection) => {
    ids.value = selection.map((item) => item.id);
    single.value = selection.length != 1;
    multiple.value = !selection.length;
  };

  // 新增按钮操作
  const handleAdd = (row) => {
    reset();
    open.value = true;
    title.value = "添加工具";
  };

  // 点击表格上的修改按钮
  // const handleSelecterUpdate = () => {
  //   const targetId = ids.value[0];
  //   formLoading.value = true;
  //   getToolDetailById(targetId).then((res) => {
  //     handleUpdate(res.data);
  //   });
  // };

  // 修改按钮操作
  const handleUpdate = (row) => {
    reset();
    open.value = true;
    formLoading.value = true;
    getToolDetailById(row.id)
      .then((res) => {
        form.value = {
          id: row.id,
          toolName: res.data.toolName,
        };
        title.value = "修改工具";
      })
      .finally(() => (formLoading.value = false));
  };
  // 删除按钮操作
  const handleDelete = (row) => {
    const toolIds = row.id || ids.value;
    proxy.$modal
      .confirm("是否确认删除该常用工具？")
      .then(function () {
        return toolDelete(toolIds);
      })
      .then(() => {
        getList();
        proxy.$modal.msgSuccess("删除成功");
      })
      .catch(() => {});
  };

  return {
    toolList,
    loading,
    single,
    multiple,
    handleAdd,
    // handleSelecterUpdate,
    handleUpdate,
    handleDelete,
    handleSelectionChange,
  };
};

export default useTable;
